- Main Page
- Classes
- Files
- Directories
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions

# FbxLight Class Reference

This reference page is linked to from the following overview topics: FBX SDK 2013, Supported Scene Elements, Connections, Nodes and the Scene Graph, FBX Nodes, FBX Node Attributes, Lights, List of Python Fbx classes.

Search for all occurrences

## Detailed Description

This node attribute contains methods for accessing the properties of a light.

Examples:

  ExportDocument/main.cxx, ExportScene04/main.cxx, ImportScene/DisplayAnimation.cxx, ImportScene/DisplayLight.cxx, ViewScene/DrawScene.cxx, ViewScene/SceneCache.cxx, ViewScene/SceneCache.h, and ViewScene/SceneContext.cxx.

Definition at line 29 of file fbxlight.h.

`#include <fbxlight.h>`

Inheritance diagram for FbxLight:
[legend]

List of all members.

## Public Member Functions
virtual FbxNodeAttribute::EType | GetAttributeType () const
| Return the type of node attribute.
## Protected Member Functions
| FbxLight (FbxManager &pManager, char const *pName)
virtual bool | ConstructProperties (bool pForceSet)
virtual FbxStringList | GetTypeFlags () const
## Light Properties
enum | EType { ePoint, eDirectional, eSpot, eArea, eVolume }
| Light types. More...
enum | EDecayType { eNone, eLinear, eQuadratic, eCubic }
| Decay types. More...
enum | EAreaLightShape { eRectangle, eSphere }
| Supported area light types. More...
void | SetShadowTexture (FbxTexture *pTexture)
| Set the shadow texture for the light.
FbxTexture * | GetShadowTexture () const
| Get the light state.
## Properties
FbxPropertyT< EType > | LightType
| This property handles the light type.
FbxPropertyT< FbxBool > | CastLight
| This property handles the cast light on object flag.
FbxPropertyT< FbxBool > | DrawVolumetricLight
| This property handles the draw volumetric light flag.
FbxPropertyT< FbxBool > | DrawGroundProjection
| This property handles the draw ground projection flag.
FbxPropertyT< FbxBool > | DrawFrontFacingVolumetricLight
| This property handles the draw facing volumetric projection flag.
FbxPropertyT< FbxDouble3 > | Color
| This property handles the light color.
FbxPropertyT< FbxDouble > | Intensity
| This property handles the light intensity.
FbxPropertyT< FbxDouble > | InnerAngle
| This property handles the light inner cone angle (in degrees).
FbxPropertyT< FbxDouble > | OuterAngle
| This property handles the light outer cone angle (in degrees).
FbxPropertyT< FbxDouble > | Fog
| This property handles the light fog intensity.
FbxPropertyT< EDecayType > | DecayType
| This property handles the decay type.
FbxPropertyT< FbxDouble > | DecayStart
| This property handles the decay start distance.
FbxPropertyT< FbxString > | FileName
| This property handles the gobo file name.
FbxPropertyT< FbxBool > | EnableNearAttenuation
| This property handles the enable near attenuation flag.
FbxPropertyT< FbxDouble > | NearAttenuationStart
| This property handles the near attenuation start distance.
FbxPropertyT< FbxDouble > | NearAttenuationEnd
| This property handles the near end attenuation.
FbxPropertyT< FbxBool > | EnableFarAttenuation
| This property handles the enable far attenuation flag.
FbxPropertyT< FbxDouble > | FarAttenuationStart
| This property handles the far attenuation start distance.
FbxPropertyT< FbxDouble > | FarAttenuationEnd
| This property handles the attenuation end distance.
FbxPropertyT< FbxBool > | CastShadows
| This property handles the cast shadow flag.
FbxPropertyT< FbxDouble3 > | ShadowColor
| This property handles the shadow color.
FbxPropertyT< EAreaLightShape > | AreaLightShape
| This property handles type when LightType is eArea.
FbxPropertyT< FbxFloat > | LeftBarnDoor
| This property handles the left barn door angle.
FbxPropertyT< FbxFloat > | RightBarnDoor
| This property handles the right barn door angle.
FbxPropertyT< FbxFloat > | TopBarnDoor
| This property handles the top barn door angle.
FbxPropertyT< FbxFloat > | BottomBarnDoor
| This property handles the bottom barn door angle.
FbxPropertyT< FbxBool > | EnableBarnDoor
| This property handles active status of barn doors.

## Member Enumeration Documentation

enum EType

Search for all occurrences

Light types.

- ePoint
- eDirectional
- eSpot
- eArea
- eVolume

Enumerator:

  ePoint | Search for all occurrences
  eDirectional | Search for all occurrences
  eSpot | Search for all occurrences
  eArea | Search for all occurrences
  eVolume | Search for all occurrences

Reimplemented from FbxNodeAttribute.

Definition at line 45 of file fbxlight.h.

            {
                ePoint,
                eDirectional,
                eSpot,
                eArea,
                eVolume
            };

enum EDecayType

Search for all occurrences

Decay types.

Used for setting the attenuation of the light.

- eNone No decay. The light's intensity will not diminish with distance.
- eLinear Linear decay. The light's intensity will diminish linearly with the distance from the light.
- eQuadratic Quadratic decay. The light's intensity will diminish with the squared distance from the light. This is the most physically accurate decay rate.
- eCubic Cubic decay. The light's intensity will diminish with the cubed distance from the light.

Enumerator:

  eNone | Search for all occurrences
  eLinear | Search for all occurrences
  eQuadratic | Search for all occurrences
  eCubic | Search for all occurrences

Definition at line 61 of file fbxlight.h.

            {
                eNone,
                eLinear,
                eQuadratic,
                eCubic
            };

enum EAreaLightShape

Search for all occurrences

Supported area light types.

- eRectangle Rectangle (or often called a plane) area light type.
- eSphere Area light that illuminate all directions.

Enumerator:

  eRectangle | Search for all occurrences
  eSphere | Search for all occurrences

Definition at line 73 of file fbxlight.h.

            {
                eRectangle,
                eSphere
            };

## Constructor & Destructor Documentation

FbxLight | ( | FbxManager & | pManager,
|  | char const * | pName
| ) |  | `[protected]`

## Member Function Documentation

void SetShadowTexture | ( | FbxTexture * | pTexture | ) |

Search for all occurrences

Set the shadow texture for the light.

Parameters:

  pTexture | The texture cast by the light shadow.

FbxTexture* GetShadowTexture | ( |  | ) | const

Search for all occurrences

Get the light state.

Returns:
  Pointer to the texture cast by the light shadow, or `NULL` if the shadow texture has not been set.

virtual FbxNodeAttribute::EType GetAttributeType | ( |  | ) | const `[virtual]`

Search for all occurrences

Return the type of node attribute.

This class is pure virtual.

Reimplemented from FbxNodeAttribute.

virtual bool ConstructProperties | ( | bool | pForceSet | ) | `[protected, virtual]`

Search for all occurrences

Reimplemented from FbxNodeAttribute.

virtual FbxStringList GetTypeFlags | ( |  | ) | const `[protected, virtual]`

Search for all occurrences

Reimplemented from FbxObject.

## Member Data Documentation

FbxPropertyT<EType> LightType

Search for all occurrences

This property handles the light type.

Default value is ePoint

Examples:
  ExportDocument/main.cxx, ExportScene04/main.cxx, ImportScene/DisplayLight.cxx, and ViewScene/SceneCache.cxx.

Definition at line 98 of file fbxlight.h.

FbxPropertyT<FbxBool> CastLight

Search for all occurrences

This property handles the cast light on object flag.

Default value is true

Examples:
  ExportScene04/main.cxx, and ImportScene/DisplayLight.cxx.

Definition at line 104 of file fbxlight.h.

FbxPropertyT<FbxBool> DrawVolumetricLight

Search for all occurrences

This property handles the draw volumetric light flag.

Default value is true

Examples:
  ExportScene04/main.cxx, and ImportScene/DisplayLight.cxx.

Definition at line 110 of file fbxlight.h.

FbxPropertyT<FbxBool> DrawGroundProjection

Search for all occurrences

This property handles the draw ground projection flag.

Default value is true

Examples:
  ExportScene04/main.cxx, and ImportScene/DisplayLight.cxx.

Definition at line 116 of file fbxlight.h.

FbxPropertyT<FbxBool> DrawFrontFacingVolumetricLight

Search for all occurrences

This property handles the draw facing volumetric projection flag.

Default value is false

Examples:
  ExportScene04/main.cxx, and ImportScene/DisplayLight.cxx.

Definition at line 122 of file fbxlight.h.

FbxPropertyT<FbxDouble3> Color

Search for all occurrences

This property handles the light color.

Default value is (1.0, 1.0, 1.0)

Reimplemented from FbxNodeAttribute.

Examples:
  ExportDocument/main.cxx, ExportScene04/main.cxx, ImportScene/DisplayLight.cxx, and ViewScene/SceneCache.cxx.

Definition at line 128 of file fbxlight.h.

FbxPropertyT<FbxDouble> Intensity

Search for all occurrences

This property handles the light intensity.

Default value is 100.0

Examples:
  ExportDocument/main.cxx, ExportScene04/main.cxx, ImportScene/DisplayAnimation.cxx, and ImportScene/DisplayLight.cxx.

Definition at line 134 of file fbxlight.h.

FbxPropertyT<FbxDouble> InnerAngle

Search for all occurrences

This property handles the light inner cone angle (in degrees).

Also know as the HotSpot

Default value is 45.0

Examples:
  ExportDocument/main.cxx, and ViewScene/SceneCache.cxx.

Definition at line 140 of file fbxlight.h.

FbxPropertyT<FbxDouble> OuterAngle

Search for all occurrences

This property handles the light outer cone angle (in degrees).

Also known as the Falloff

Default value is 45.0

Examples:
  ExportDocument/main.cxx, ExportScene04/main.cxx, ImportScene/DisplayAnimation.cxx, and ImportScene/DisplayLight.cxx.

Definition at line 146 of file fbxlight.h.

FbxPropertyT<FbxDouble> Fog

Search for all occurrences

This property handles the light fog intensity.

Default value is 50.0

Examples:
  ExportScene04/main.cxx, ImportScene/DisplayAnimation.cxx, and ImportScene/DisplayLight.cxx.

Definition at line 152 of file fbxlight.h.

FbxPropertyT<EDecayType> DecayType

Search for all occurrences

This property handles the decay type.

Default value is eNone

Definition at line 158 of file fbxlight.h.

FbxPropertyT<FbxDouble> DecayStart

Search for all occurrences

This property handles the decay start distance.

Default value is 0.0

Definition at line 164 of file fbxlight.h.

FbxPropertyT<FbxString> FileName

Search for all occurrences

This property handles the gobo file name.

Default value is ""

Examples:
  ExportScene04/main.cxx, and ImportScene/DisplayLight.cxx.

Definition at line 170 of file fbxlight.h.

FbxPropertyT<FbxBool> EnableNearAttenuation

Search for all occurrences

This property handles the enable near attenuation flag.

Default value is false

Definition at line 176 of file fbxlight.h.

FbxPropertyT<FbxDouble> NearAttenuationStart

Search for all occurrences

This property handles the near attenuation start distance.

Default value is 0.0

Definition at line 182 of file fbxlight.h.

FbxPropertyT<FbxDouble> NearAttenuationEnd

Search for all occurrences

This property handles the near end attenuation.

Default value is 0.0

Definition at line 188 of file fbxlight.h.

FbxPropertyT<FbxBool> EnableFarAttenuation

Search for all occurrences

This property handles the enable far attenuation flag.

Default value is false

Definition at line 194 of file fbxlight.h.

FbxPropertyT<FbxDouble> FarAttenuationStart

Search for all occurrences

This property handles the far attenuation start distance.

Default value is 0.0

Definition at line 200 of file fbxlight.h.

FbxPropertyT<FbxDouble> FarAttenuationEnd

Search for all occurrences

This property handles the attenuation end distance.

Default value is 0.0

Definition at line 206 of file fbxlight.h.

FbxPropertyT<FbxBool> CastShadows

Search for all occurrences

This property handles the cast shadow flag.

Default value is false

Definition at line 212 of file fbxlight.h.

FbxPropertyT<FbxDouble3> ShadowColor

Search for all occurrences

This property handles the shadow color.

Default value is (0.0, 0.0, 0.0)

Definition at line 218 of file fbxlight.h.

FbxPropertyT<EAreaLightShape> AreaLightShape

Search for all occurrences

This property handles type when LightType is eArea.

Default value is eRectangle

Definition at line 224 of file fbxlight.h.

FbxPropertyT<FbxFloat> LeftBarnDoor

Search for all occurrences

This property handles the left barn door angle.

Default value is 20.0

Definition at line 230 of file fbxlight.h.

FbxPropertyT<FbxFloat> RightBarnDoor

Search for all occurrences

This property handles the right barn door angle.

Default value is 20.0

Definition at line 236 of file fbxlight.h.

FbxPropertyT<FbxFloat> TopBarnDoor

Search for all occurrences

This property handles the top barn door angle.

Default value is 20.0

Definition at line 242 of file fbxlight.h.

FbxPropertyT<FbxFloat> BottomBarnDoor

Search for all occurrences

This property handles the bottom barn door angle.

Default value is 20.0

Definition at line 248 of file fbxlight.h.

FbxPropertyT<FbxBool> EnableBarnDoor

Search for all occurrences

This property handles active status of barn doors.

Default value is false

Definition at line 254 of file fbxlight.h.

The documentation for this class was generated from the following file:

- fbxsdk/scene/geometry/fbxlight.h

FbxLight FbxLight FbxLight FbxLight FbxLight FbxLight FbxLight FbxLight FbxLight FbxLight
FbxLight FbxLight FbxLight FbxLight FbxLight FbxLight FbxLight FbxLight FbxLight FbxLight